
/*  g3DGMV
 *  Copyright (C) <1999> <NICK YOST>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <config.h>
#include <gdk_imlib.h>
#include <gtk/gtk.h>
#include "g3DGMVsrc.h"
#include "g3DGMVsig.h"
#include <gnome.h>
/* DEM converter */
#include <math.h>
#include "LatLong-UTMconversion.h"
#include "dms.h"
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/errno.h>

/*#include "tsm/tsm.h"*/
static int WPcount=0;
static gint  last = 0;
gint list_row = -1;
gint list_column = 0;
/*gchar *text_buff[1][4];*/



int
main (int argc, char *argv[])
{
  GtkWidget *Map;
  
 

  gtk_set_locale ();
  // gtk_init (&argc, &argv);
  gnome_init (PACKAGE, VERSION, argc, argv);
  gdk_imlib_init();
  
  /* get gdk to use imlib's visual and colormap */
  gtk_widget_push_visual(gdk_imlib_get_visual());
  gtk_widget_push_colormap(gdk_imlib_get_colormap());

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  Map = create_Mapper (); 
  gtk_widget_set_usize( Map, 513, 460);
  gtk_widget_show_all(Map);
  gtk_signal_connect (GTK_OBJECT (Map), "delete_event",
  		      GTK_SIGNAL_FUNC (delete_event), NULL);
  
 
  gtk_main ();
  return 0;
}

int get_WayPoint_count(int value){
  if (value >= 0)
    WPcount=value;
  return WPcount;
}

void
button_clear_clicked                     (GtkWidget *button, gpointer data )
{
 GtkWidget *entry_1, *entry_2,*entry_3,*entry_4;

  entry_1 =get_widget ((GtkWidget *) data, "entry4");
  //gtk_entry_set_text((GtkEntry *) entry_1, "\0");
  gtk_editable_delete_text(GTK_EDITABLE  (entry_1),0,-1);
  entry_2 =get_widget ((GtkWidget *) data, "entry5");
  //gtk_entry_set_text((GtkEntry *) entry_2, "\0");
  gtk_editable_delete_text(GTK_EDITABLE  (entry_2),0,-1);
  entry_3 =get_widget ((GtkWidget *) data, "entry6");
  //gtk_entry_set_text((GtkEntry *) entry_3, "\0");
  gtk_editable_delete_text(GTK_EDITABLE  (entry_3),0,-1);
  entry_4 =get_widget ((GtkWidget *) data, "entry7");
  //gtk_entry_set_text((GtkEntry *) entry_4, "\0");
  gtk_editable_delete_text(GTK_EDITABLE  (entry_4),0,-1);
  
   last =0;
 
   return;
 }

void
button_add_clicked                     (GtkWidget *button, gpointer data )
{
GtkWidget *clist;
GtkWidget *Mapper; 
GtkWidget *entry_1, *entry_2,*entry_3,*entry_4;

char buff[40];
gchar Zoneformat[80];
gchar *format[4];
GtkWidget *button1, *button2, *button3, *button4, *button5;
  Mapper  = get_widget ((GtkWidget *) data, "Mapper");
  button1 = get_widget ((GtkWidget *) data, "radiobutton1"); 
  button2 = get_widget ((GtkWidget *) data, "radiobutton2");
  button3 = get_widget ((GtkWidget *) data, "radiobutton3");
  button4 = get_widget ((GtkWidget *) data, "radiobutton4");
  button5 = get_widget ((GtkWidget *) data, "radiobutton5");

 clist = get_widget ((GtkWidget *) data, "clist3"); 
 entry_1 =get_widget ((GtkWidget *) data, "entry4");
 format [0] = gtk_entry_get_text((GtkEntry *) entry_1);

 entry_2 =get_widget ((GtkWidget *) data, "entry5");
 format [1] = gtk_entry_get_text((GtkEntry *) entry_2);
 
 entry_3 =get_widget ((GtkWidget *) data, "entry6");
 format [2] = gtk_entry_get_text((GtkEntry *) entry_3);

 entry_4 =get_widget ((GtkWidget *) data, "entry7");

 if (GTK_TOGGLE_BUTTON (button1)->active)
   format[3] = "ddmm.mmmm'";
 else if (GTK_TOGGLE_BUTTON (button2)->active)
   format[3] = "ddmm'ss.ss\"";
 else if (GTK_TOGGLE_BUTTON (button3)->active)
   format[3] = "degree";
 else if (GTK_TOGGLE_BUTTON (button4)->active)
   format[3] = "arc sec\"";
 else if (GTK_TOGGLE_BUTTON (button5)->active){
   sprintf(Zoneformat, "UTM Zone %s", 
	   gtk_entry_get_text((GtkEntry *) entry_4));
   format[3] = Zoneformat;}


 g_snprintf( buff, 40,"Waypoint has been added to list");

 if ( format[0] != "\n" ) 
 gtk_clist_append((GtkCList*) clist, format);
 gtk_grab_add(Mapper);
 DrawWP(data);WPcount++;
 gtk_grab_remove(Mapper);
 push_item(NULL,buff);

return;

}

void
on_File_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

  /*  refNum = fopen(FileName, "wt");
      getGPSInfo(refNum, WAYPOINT); */
  
}

void
on_File_open_activate                  (GtkMenuItem     *menuitem,
					gpointer         user_data)
{
  GtkWidget *fileselection1; 

  fileselection1 = create_fileselection1();

  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->cancel_button ),
			     "clicked", (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (fileselection1));


 return;
}

void
on_Help_about_activate                  (GtkMenuItem     *menuitem,
					 gpointer         user_data)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *packer12;
  GtkWidget *label10;
  GdkPixmap *glade_pixmap;
  GdkBitmap *glade_mask;
  GtkWidget *pixmap2;
  GtkWidget *dialog_action_area1;
  GtkWidget *button4;

  dialog1 = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  GTK_WINDOW(dialog1)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_title (GTK_WINDOW (dialog1), "About Mapper");
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  packer12 = gtk_packer_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "packer12", packer12);
  gtk_widget_show (packer12);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), packer12, TRUE, TRUE, 0);
  // gtk_container_border_width (GTK_CONTAINER (packer12), 16);

  label10 = gtk_label_new ("g3DGMV Mapping Program, Version 0.2\nDecember 23, 1999\nAuthor: Nick Yost \nhttp://members.linuxstart.com/~g3DGMV\nThe g3DGMV program was design as a \nviewer for Digital Elevation Model\n(DEM) and Digital Line Graphs (DLG)\n");
  gtk_object_set_data (GTK_OBJECT (dialog1), "label10", label10);
  gtk_widget_show (label10);
  gtk_packer_add (GTK_PACKER (packer12), label10, GTK_SIDE_TOP,
                  GTK_ANCHOR_CENTER, 0,
                  0, 0, 0, 0, 0);

  gtk_widget_realize (dialog1);
  glade_pixmap = gdk_pixmap_create_from_xpm (dialog1->window, &glade_mask,
                                             &dialog1->style->bg[GTK_STATE_NORMAL],
                                             "./pixmaps/world2.xpm");
  pixmap2 = gtk_pixmap_new (glade_pixmap, glade_mask);
  gdk_pixmap_unref (glade_pixmap);
  gdk_bitmap_unref (glade_mask);
  gtk_object_set_data (GTK_OBJECT (dialog1), "pixmap2", pixmap2);
  gtk_widget_show (pixmap2);
  gtk_packer_add (GTK_PACKER (packer12), pixmap2, GTK_SIDE_TOP,
                  GTK_ANCHOR_CENTER, 0,
                  0, 0, 0, 0, 0);
  gtk_widget_set_usize (pixmap2, 228, 86);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 10);


  button4 = gtk_button_new_with_label ("OK");
  gtk_object_set_data (GTK_OBJECT (dialog1), "button4", button4);
  gtk_signal_connect_object (GTK_OBJECT (button4), "clicked", 
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (dialog1));
  gtk_widget_show (button4);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), button4, FALSE, FALSE, 0);
  gtk_widget_set_usize (button4, 51, -1);
  gtk_widget_show(dialog1);

return;					
}

void
on_File_exit_activate                  (GtkMenuItem     *menuitem,
					gpointer         user_data)
{
  gtk_main_quit ();
}


void
on_Edit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_Edit_copy_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         data)
{
 GtkWidget *clist;
  GtkWidget *tmplist;
  gchar *text_buff[4];

  if(list_row > -1 ){
  clist = get_widget ((GtkWidget *) data, "clist3");
  tmplist = get_widget ((GtkWidget *) data, "tmplist"); 
  gtk_clist_clear((GtkCList *) tmplist);
  gtk_clist_get_text(GTK_CLIST(clist), list_row, 0, &text_buff[0]);
  gtk_clist_get_text(GTK_CLIST(clist), list_row, 1, &text_buff[1]);
  gtk_clist_get_text(GTK_CLIST(clist), list_row, 2, &text_buff[2]);
  gtk_clist_get_text(GTK_CLIST(clist), list_row, 3, &text_buff[3]);

  gtk_clist_insert(GTK_CLIST(tmplist), 0, text_buff);}

  return;
}

void
on_Edit_paste_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         data)
{
  GtkWidget *clist;
  GtkWidget *tmplist;
  gchar *text_buff[4];

 
  clist = get_widget ((GtkWidget *) data, "clist3");
  tmplist = get_widget ((GtkWidget *) data, "tmplist"); 

  if( gtk_clist_get_text(GTK_CLIST( tmplist), 0, 0, &text_buff[0])){
    gtk_clist_get_text(GTK_CLIST( tmplist), 0, 1, &text_buff[1]);
    gtk_clist_get_text(GTK_CLIST( tmplist), 0, 2, &text_buff[2]);
    gtk_clist_get_text(GTK_CLIST( tmplist), 0, 3, &text_buff[3]);
    list_row++;WPcount++;
    gtk_clist_insert(GTK_CLIST(clist), list_row, text_buff);
    DrawWP(data);}

  return;
}

void
on_Edit_delete_activate                       (GtkMenuItem     *menuitem,
					       gpointer         data)
{
  GtkWidget *clist;

  clist = get_widget ((GtkWidget *) data, "clist3");
  gtk_clist_clear((GtkCList *) clist);
  WPcount=0;
  return;
}

void
on_Edit_remove_activate                       (GtkMenuItem     *menuitem,
					       gpointer         data)
{
  GtkWidget *clist;
  GtkWidget *tmplist;
  gchar *text_buff[4];

  if(list_row >= 0){
  clist = get_widget ((GtkWidget *) data, "clist3");
  tmplist = get_widget ((GtkWidget *) data, "tmplist"); 
  gtk_clist_clear((GtkCList *) tmplist);
  gtk_clist_get_text(GTK_CLIST(clist), list_row, 0, &text_buff[0]);
  gtk_clist_get_text(GTK_CLIST(clist), list_row, 1, &text_buff[1]);
  gtk_clist_get_text(GTK_CLIST(clist), list_row, 2, &text_buff[2]);
  gtk_clist_get_text(GTK_CLIST(clist), list_row, 3, &text_buff[3]);

  gtk_clist_insert(GTK_CLIST(tmplist), 0, text_buff);
  gtk_clist_remove((GtkCList *) clist, list_row);
  list_row--;WPcount--;}
  return;
}

void
selection_made                     (GtkWidget *clist, gint row, gint column,
				     GdkEventButton *event, gpointer data)
{
 list_column = column;
 list_row = row;

 return;
}
void
on_Help_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}



/* global position format convertion routines*/
void
button_arc_seconds_format                   (GtkWidget    *widget,
                                        gpointer         data)
{
  int ReferenceEllipsoid = 23;
  double Lat, Long;
  double UTMNorthing, UTMEasting;
  float  fUTMNorthing, fUTMEasting;
  char UTMZone[4]="11T" ;
  GtkWidget *combo, *entry_1,*entry_2,*entry_3;
  gchar *format;
  gchar buff[64];

  if (last == 0) {last =4;}

  entry_1 =get_widget ((GtkWidget *) data, "entry5");
  format = gtk_entry_get_text((GtkEntry *) entry_1);

  if(strcmp(format,"\n")!=0){ 
   entry_2 =get_widget ((GtkWidget *) data, "entry6");
   entry_1 =get_widget ((GtkWidget *) data, "entry5");
   
   /* GET Reference Ellipsoid */
   combo = get_widget ((GtkWidget *) data, "combo6");
   format = gtk_entry_get_text( (GtkEntry *)(GTK_COMBO (combo)->entry) );        ReferenceEllipsoid = get_ellipsoid_id ( format );


  if (GTK_TOGGLE_BUTTON (widget)->active){
    switch (last)
      {
       case 1 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
         format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s",toAS(DMStoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s",toAS(DMStoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
       case 2 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s",toAS(DMtoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s",toAS(DMtoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
       case 3 :
         entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s", toAS(atof(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s", toAS(atof(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
	 break;
       case 4 :
         entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s", toAS( AStoDegree(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s", toAS( AStoDegree(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
      case 5 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 sscanf(format, "%f", &fUTMNorthing);
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 sscanf(format, "%f", &fUTMEasting);
         entry_3 =get_widget ((GtkWidget *) data, "entry7");
         format = gtk_entry_get_text((GtkEntry *) entry_3);
         sscanf(format, "%s", UTMZone);
         UTMEasting = (double) fUTMEasting;
         UTMNorthing = (double)fUTMNorthing;
	 UTMtoLL(ReferenceEllipsoid, UTMNorthing, UTMEasting, UTMZone,
	    &Lat, &Long );
         sprintf (buff, "%s",toAS(Lat));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 sprintf (buff, "%s",toAS(Long));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
      }
  }}
  last =4;
}

/***************NEW UTM***/
void
button_UTM_format                   (GtkWidget    *widget,
                                        gpointer         data)
{
  int ReferenceEllipsoid = 23;
  double Lat, Long;
  double UTMNorthing, UTMEasting;
  //float  fUTMNorthing, fUTMEasting;
  char UTMZone[4]="11T" ;
  GtkWidget *combo, *entry_1,*entry_2,*entry_3;
  gchar *format;
  gchar buff[64];

  if (last == 0) {last =5;}

  entry_1 =get_widget ((GtkWidget *) data, "entry5");
  format = gtk_entry_get_text((GtkEntry *) entry_1);

   if(strcmp(format,"\n")!=0){ 
   entry_2 =get_widget ((GtkWidget *) data, "entry6");
   entry_1 =get_widget ((GtkWidget *) data, "entry5");
   
   
   // GET Reference Ellipsoid 
   combo = get_widget ((GtkWidget *) data, "combo6");
   format = gtk_entry_get_text( (GtkEntry *)(GTK_COMBO (combo)->entry) );         ReferenceEllipsoid = get_ellipsoid_id ( format );

   if (GTK_TOGGLE_BUTTON (widget)->active){
    switch (last)
      {
       case 1 :
         entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 Lat=DMStoDegrees(format);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 Long=DMStoDegrees(format);
	 LLtoUTM( ReferenceEllipsoid, Lat, Long,&UTMNorthing,
	 &UTMEasting, UTMZone);
	 sprintf (buff, "%f meters",UTMNorthing);
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 sprintf (buff, "%f   meters",UTMEasting);
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
         entry_3 =get_widget ((GtkWidget *) data, "entry7");
	 gtk_entry_set_text((GtkEntry *) entry_3, UTMZone);
	 break;
	  
       case 2 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 Lat=DMtoDegrees(format);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 Long=DMtoDegrees(format);
	 LLtoUTM( ReferenceEllipsoid, Lat, Long,&UTMNorthing,
	 &UTMEasting, UTMZone);
	 sprintf (buff, "%f meters",UTMNorthing);
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 sprintf (buff, "%f   meters",UTMEasting);
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
         entry_3 =get_widget ((GtkWidget *) data, "entry7");
	 gtk_entry_set_text((GtkEntry *) entry_3, UTMZone);
	 break;

       case 3 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 Lat=DMtoDegrees(toDM(atof(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 Long=DMtoDegrees(toDM(atof(format)));
	 LLtoUTM( ReferenceEllipsoid, Lat, Long,&UTMNorthing,
	 &UTMEasting, UTMZone);
	 sprintf (buff, "%f meters",UTMNorthing);
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 sprintf (buff, "%f   meters",UTMEasting);
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
         entry_3 =get_widget ((GtkWidget *) data, "entry7");
	 gtk_entry_set_text((GtkEntry *) entry_3, UTMZone);
         break;

        case 4 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 Lat=AStoDegree(format);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 Long=AStoDegree(format);
	 LLtoUTM( ReferenceEllipsoid, Lat, Long,&UTMNorthing,
	 &UTMEasting, UTMZone);
	 sprintf (buff, "%f meters",UTMNorthing);
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 sprintf (buff, "%f   meters",UTMEasting);
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
         entry_3 =get_widget ((GtkWidget *) data, "entry7");
	 gtk_entry_set_text((GtkEntry *) entry_3, UTMZone);
	 break;
      }
  }}

  last =5;      
}

void
button_Auto_format                   (GtkWidget    *button,
                                        gpointer         data)
{
 
}

void
remove_char_format                   (char*  str)
{
 char ch;
 int i=0;

 while( str[i] !='\0'){
    ch =str[i];
    if( !isdigit(ch = str[i] ) && ( str[i] != '.') &&( str[i] != '-') )
        str[i]= ' ';
    i++;
 }
  
  return;
  
}

void
button_DDMM_format                   (GtkWidget    *widget,
                                        gpointer         data)
{
  int ReferenceEllipsoid = 23;
  double Lat, Long;
  double UTMNorthing, UTMEasting;
  float  fUTMNorthing, fUTMEasting;
  char UTMZone[4]="11T" ;
  GtkWidget *combo,*entry_1,*entry_2,*entry_3;
  gchar *format;
  gchar buff[64];

  /* GET Reference Ellipsoid */
   combo =get_widget ((GtkWidget *) data, "combo6");
   format = gtk_entry_get_text( (GtkEntry *)(GTK_COMBO (combo)->entry) );         ReferenceEllipsoid = get_ellipsoid_id ( format );

  if (last == 0) {last =2;}

  entry_1 =get_widget ((GtkWidget *) data, "entry5");
  format = gtk_entry_get_text((GtkEntry *) entry_1);

if(strcmp(format,"\n")!=0){
  if (GTK_TOGGLE_BUTTON (widget)->active){
    switch (last)
      {
       case 1 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
         format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDM(DMStoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDM(DMStoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
       case 2 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDM(DMtoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDM(DMtoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
       case 3 :
         entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s", toDM(atof(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s", toDM(atof(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
        case 4 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDM(AStoDegree(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDM(AStoDegree(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
      case 5 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 sscanf(format, "%f",&fUTMNorthing);
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 sscanf(format, "%f",&fUTMEasting);
         entry_3 =get_widget ((GtkWidget *) data, "entry7");
         format = gtk_entry_get_text((GtkEntry *) entry_3);
         sscanf(format, "%s", UTMZone);
         UTMEasting = (double) fUTMEasting;
         UTMNorthing = (double)fUTMNorthing;
	 UTMtoLL(ReferenceEllipsoid, UTMNorthing, UTMEasting, UTMZone,
	    &Lat, &Long );
         sprintf (buff, "%s",toDM(Lat));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 sprintf (buff, "%s",toDM(Long));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
         break;
      }
  }}
    last =2;

}

void
button_DDMMSS_format                   (GtkWidget    *widget,
                                        gpointer         data)
{
  int ReferenceEllipsoid = 23;
  double Lat, Long;
  double UTMNorthing, UTMEasting;
  float  fUTMNorthing, fUTMEasting;
  char UTMZone[4]="11T" ;
  GtkWidget *combo,*entry_1,*entry_2,*entry_3;
  gchar *format;
  gchar buff[64];

   /* GET Reference Ellipsoid */
   combo =get_widget ((GtkWidget *) data, "combo6");
   format = gtk_entry_get_text( (GtkEntry *)(GTK_COMBO (combo)->entry) );         ReferenceEllipsoid = get_ellipsoid_id ( format );

  if (last == 0) {last =1;}

  entry_1 =get_widget ((GtkWidget *) data, "entry5");
  format = gtk_entry_get_text((GtkEntry *) entry_1);

if(strcmp(format,"\n")!=0){
  if (GTK_TOGGLE_BUTTON (widget)->active){
     
     switch (last)
       {
       case 1 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
         format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDMS(DMStoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDMS(DMStoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
         break;
       case 2 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDMS(DMtoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDMS(DMtoDegrees(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
       case 3 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDMS(atof(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDMS(atof(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
      case 4 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDMS(AStoDegree(format)));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%s",toDMS(AStoDegree(format)));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
       case 5 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 sscanf(format, "%f", &fUTMNorthing);
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 sscanf(format,"%f",&fUTMEasting);
         entry_3 =get_widget ((GtkWidget *) data, "entry7");
         format = gtk_entry_get_text((GtkEntry *) entry_3);
         sscanf(format, "%s", UTMZone);
         UTMEasting = (double) fUTMEasting;
         UTMNorthing = (double)fUTMNorthing;
	 UTMtoLL(ReferenceEllipsoid, UTMNorthing, UTMEasting, UTMZone,
	    &Lat, &Long );
         sprintf (buff, "%s",toDMS(Lat));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 sprintf (buff, "%s",toDMS(Long));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
         break;
       }
  }}
  last =1;

}

void
button_DEGREES_format                   (GtkWidget    *widget,
                                        gpointer         data)
{
  int ReferenceEllipsoid = 23;
  double Lat, Long;
  double UTMNorthing, UTMEasting;
  float  fUTMNorthing, fUTMEasting;
  char UTMZone[4]="11T" ;
  GtkWidget *combo,*entry_1,*entry_2,*entry_3;
  gchar *format;
  gchar buff[64];

  entry_2 =get_widget ((GtkWidget *) data, "entry6");
  entry_1 =get_widget ((GtkWidget *) data, "entry5");

   /* GET Reference Ellipsoid */
   combo =get_widget ((GtkWidget *) data, "combo6");
   format = gtk_entry_get_text( (GtkEntry *)(GTK_COMBO (combo)->entry) );         ReferenceEllipsoid = get_ellipsoid_id ( format );

  if (last == 0) {last =3;}

  entry_1 =get_widget ((GtkWidget *) data, "entry5");
  format = gtk_entry_get_text((GtkEntry *) entry_1);
 
if(strcmp(format,"\n")!=0){
  if (GTK_TOGGLE_BUTTON (widget)->active){
    switch (last)
       {
       case 2 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%f",DMtoDegrees(format));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%f",DMtoDegrees(format));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
       case 1 :
         entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%f",DMStoDegrees(format));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%f",DMStoDegrees(format));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
       case 3 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%f",DMtoDegrees(toDM(atof(format))));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%f",DMtoDegrees(toDM(atof(format))));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
         break;
        case 4 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 remove_char_format(format);
	 sprintf (buff, "%f",AStoDegree(format));
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 remove_char_format(format);
	 sprintf (buff, "%f",AStoDegree(format));
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
	 break;
       case 5 :
	 entry_1 =get_widget ((GtkWidget *) data, "entry5");
	 format = gtk_entry_get_text((GtkEntry *) entry_1);
	 sscanf(format, "%f", &fUTMNorthing);
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 entry_2 =get_widget ((GtkWidget *) data, "entry6");
	 format = gtk_entry_get_text((GtkEntry *) entry_2);
	 sscanf(format, "%f", &fUTMEasting);
         entry_3 =get_widget ((GtkWidget *) data, "entry7");
         format = gtk_entry_get_text((GtkEntry *) entry_3);
         sscanf(format, "%s", UTMZone);
         UTMEasting = (double) fUTMEasting;
         UTMNorthing = (double)fUTMNorthing;
	 UTMtoLL(ReferenceEllipsoid, UTMNorthing, UTMEasting, UTMZone,
	    &Lat, &Long );
         sprintf (buff, "%f",Lat);
	 gtk_entry_set_text((GtkEntry *) entry_1, buff);
	 sprintf (buff, "%f",Long);
	 gtk_entry_set_text((GtkEntry *) entry_2, buff);
         break;
       }}
    last = 3;
    }

}


